<template>
  <div id='art'>
    <div class="box">
      <div class="date-container">
        <date-picker class="date-picker" v-model="dates" lang="en" type="month" format="YYYY-MM">
        </date-picker>
        <button @click="format()">Confirm Date</button>
        <div v-if="datebool">
          <loader></loader>
        </div>
      </div>
      <br /><br />
      <div>
        <br>
        <label for="section"></label>
        <select class="select-one"
          @change="onChange($event)"
          name="section"
          id="section"
          v-model="selectedSection"
        >
          <option value="default" selected="selected" disabled>Choose a section</option>
          <option v-for="(section, index) in sections" v-bind:key="index">
            {{ section }}
          </option>
        </select>
        <div v-if="secbool">
          <loader></loader>
        </div>
      </div>
      <div>
        <label for="subsection"></label>
        <select class="select-two"
          @change="show1() ,getData()"
          name="subsection"
          id="subsection"
          v-model="selectedSubsection"
        >
          <option value="default" selected="selected" disabled>Choose a subsection</option>
          <option v-for="(subsection, index) in subsections" v-bind:key="index">
            {{ subsection }}
          </option>
        </select>
      </div>
    </div>
  
    <div class="dugme">
       <section class="section">
      <button @click="show1(), getData()" class="button">Articles Table</button>
      <button @click="show2()" class="button">Articles By Author</button>
      <button @click="show3()" class="button">Articles Per Day</button>
      </section>
      <div class="test">
        <div v-if="proba" class="table">
          <table class="u-pull-right ">
            <tr>
              <td>Add to favorites</td>
              <td>Headline</td>
              <td>Abstract</td>
              <td class="link"> Link</td>
              <td>Lead Paragraph</td>
              <td>Authors</td>
              <td>Publication Date</td>
              <td>Word Count</td>
            </tr>
            <tr v-for="(item,index) in lista" :key="index" class="row">
              <td><button @click="addArticle(index)" v-if="!item.favorite" class="add-button">ADD</button></td>
              <td>{{ item.headline_main }}</td>
              <td>{{ item.abstract }}</td>
              <td>
                <a :href ="item.web_url" > Link</a>
              </td>
              <td>{{ item.lead_paragraph }}</td>
              <td>{{item.byline}}</td>
              <td>{{ item.pub_date }}</td>
              <td>{{ item.word_count }}</td>
            </tr>
            
              
            
          </table>
          <div class="pag-container">
          <div  class="pagination" >
                
                <a href="#" @click="PrevPage()">Previous</a>
                <a class="active" href="#">{{listdata.page}}</a>
                <a href="#" @click="NextPage()">Next</a>
                <a href="#">{{listdata.total_pages}}</a>
                
              </div>
              </div>
         
        </div>
        <div v-if="proba2" class="chart-width">
          <chart
            :datum="dates"
            :sec="selectedSection"
            :subsec="selectedSubsection"
          >
          </chart>
        </div>
        <div div v-if="proba3" class="chart-width">
          <chart1
            :datum="dates"
            :sec="selectedSection"
            :subSec="selectedSubsection"
          >
          </chart1>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { httpClient } from "../api/httpclient"
import DatePicker from "vue2-datepicker";
import "vue2-datepicker/index.css";
import Axios from "axios";
import "../assets/normalize.css";
import "../assets/skeleton.css";
import chart from "../components/chart.vue";
import chart1 from "../components/chart1.vue";
import loader from "../components/loader.vue"

export default {
  name: "datepicker",
  components: {
    DatePicker,
    chart,
    chart1,
    loader,
  },
  watch: {
    dates(newvalue) {
      console.log(newvalue);
    },
  },
  data() {
    return {
      show: null,
      dates: "",
      listdata: [],

      lista: [],
      test: "2019-01-15",
      sections: [],
      selectedSection: "default",
      newdate: "",
      subsections: [],
      articles: [],
      chartCheck: false,
      selectedSubsection: "default",
      proba: false,
      proba2: false,
      proba3: false,
      datebool: false,
      secbool: false,
      chartbool: false,
    };
  },
  methods: {
    format() {
      this.datebool = true;
      this.newdate = this.dates;
      console.log(this.newdate, typeof this.newdate);
      httpClient.post("/articles/sections/", {
        date: this.newdate,
      }).then((resp) => {
        this.sections = resp.data.sections;
        console.log(this.sections);
        this.datebool = false;
      });
    },
    onChange(event) {
      this.secbool=true
      httpClient.post("/articles/section/subsections/", {
        date: this.newdate,
        section: this.selectedSection,
      }).then((resp) => {
        this.subsections = resp.data.subsections;
        console.log(this.subsections);
        this.secbool=false
      });
    },
    getData() {
      httpClient.post(
        "/articles/section/subsection/articles/",
        {
          date: this.newdate,
          section: this.selectedSection,
          subsection: this.selectedSubsection,
        }
      ).then((resp) => {
        this.listdata = resp.data;
        console.log(this.listdata)

        this.lista = resp.data.articles;
        console.log(this.lista);
      });
    },
    addArticle(index) {
      this.lista[index].favorite=true
      const data = this.lista[index]
      httpClient.post("/articles/saved_list/",
      data)
    },
    checkChart() {
      this.chartCheck = !this.chartCheck;
    },
    display() {
      console.log(this.selectedSubsection);
    },
    show1() {
      this.proba = true;
      (this.proba2 = false), (this.proba3 = false);
    },
    show2() {
      this.proba2 = !this.proba2;
      this.proba=false
      this.proba3 = false;
    },
    show3() {
      this.proba3 = !this.proba3;
      this.proba = false;
      this.proba2 = false;
    },
    NextPage(){
      httpClient.post(`/${this.listdata.next_page}`,{
        date: this.newdate,
          section: this.selectedSection,
          subsection: this.selectedSubsection,
      }).then((resp) => {
        this.listdata = resp.data;
        console.log(this.listdata)

        this.lista = resp.data.articles;
        console.log(this.lista);
      });


    },
    PrevPage(){
      httpClient.post(`/${this.listdata.prev_page}`,{
        date: this.newdate,
          section: this.selectedSection,
          subsection: this.selectedSubsection,
      }).then((resp) => {
        this.listdata = resp.data;
        console.log(this.listdata)

        this.lista = resp.data.articles;
        console.log(this.lista);
      });


    }
  },
};
</script>
<style scoped>

body{
  height:100%;
  min-height: 100vh;
  height: fit-content;
  width:100%;
  padding-left: 20%;
}

#art{
  
  min-height: 100vh;
  height: 100%;
  margin:auto;
  margin-bottom: 10%;
  width:100vw;
  max-width: 100%;
  max-height: 100%;
    overflow-x: hidden;
  overflow-y: hidden;
}

.box{
  display: flex;
  justify-content: column;
  align-items: flex-end;
  margin-bottom: 150px;
  width: fit-content;
  margin:auto;
  

}
.table{
  width: 90%;
  margin: auto;
  margin-top: 20px;
}
.chart-width{
  width: fit-content;
  margin: auto;
}
.select-one {
  margin-left: 1em;
}

.select-two {
  margin-left: 1em;
}

/* .date-picker{
  padding: 0 25px;
} */

* {
  box-sizing: border-box;
}
.tabela {
  margin-top: 100px;
}
.test {
  display: flex;
  align-items: center;
  width: 100%;
 margin-top:20px;
  margin:auto;
}
.pag-container{
  width: 100%;
  display: flex;
  justify-content: center;
}

.pagination a {
  color: black;
  float: left;
  padding: 8px 16px;
  text-decoration: none;
  transition: background-color 0.3s;
}
.dugme{
  width: 100vw;
  margin: auto;
}
.dugme button{
  justify-content: center;
 
}
.section{
  width: fit-content;
  margin: auto;
  margin-top: 10px;
}
/* Style the active/current link */
.pagination a.active {
  background-color: dodgerblue;
  color: white;
}

.button {
  cursor: pointer;
  width: 199px;
  display: inline-block;
  background-color: #5E6B7F;
  color: white;
  text-align: center;
  transition: .25s ease;
  border: none;
  padding: 10px;
  border-radius: 12px 12px 0 0;
}

div:focus button, button:focus {
  background-color: #8DA1BF;
  outline: none;
}

.button:focus + p, div:focus P {
  display: block;
  position: absolute;
  background-color: #8DA1BF;
  height: 120px;
  width: 100%;
  left: 0;
  z-index: 2;
  outline: none;
  top: 0px;
  text-align: center;
  padding-top: 48px;
}

p {
  display: none;
  font-size: 2em;
}

div {
  display: inline-block;
}

div:focus {
  outline: none;
}

body {
  padding: 3em;
}

.p {
  margin-top: 300px;
  text-align: center;
  display: block;
  font-size: 1em;
}

::v-deep .mx-icon-calendar, .mx-icon-clear {
    position: absolute;
    top: 35% !important;
    right: 8px;
    -webkit-transform: translateY(-50%);
    transform: translateY(-50%);
    font-size: 16px;
    line-height: 1;
    color: rgba(0,0,0,.5);
    vertical-align: middle;
}
.date-container /deep/ mx-icon-calendar, .mx-icon-clear {
    position: absolute;
    top: 35% !important;
    right: 8px;
    -webkit-transform: translateY(-50%);
    transform: translateY(-50%);
    font-size: 16px;
    line-height: 1;
    color: rgba(0,0,0,.5);
    vertical-align: middle;
}
.date-container /deep/ .mx-icon-calendar, .mx-icon-clear {
    position: absolute;
    top: 35% !important;
    right: 8px;
    -webkit-transform: translateY(-50%);
    transform: translateY(-50%);
    font-size: 16px;
    line-height: 1;
    color: rgba(0,0,0,.5);
    vertical-align: middle;
}

</style>






